aws-0.24.4: Amazon Web Services (AWS) for Haskell

Safe Haskell | None
Language | Haskell2010

Aws.Iam.Core

Synopsis

- iamSignQuery :: [(ByteString, ByteString)] -> IamConfiguration qt -> SignatureData -> SignedQuery
- iamResponseConsumer :: (Cursor -> Response IamMetadata a) -> IORef IamMetadata -> HTTPResponseConsumer a
- data IamMetadata = IamMetadata {
  - requestId :: Maybe Text
  }
- data IamConfiguration qt = IamConfiguration {
  - iamEndpoint :: ByteString
  - iamPort :: Int
  - iamProtocol :: Protocol
  - iamHttpMethod :: Method
  }
- data IamError = IamError {
  - iamStatusCode :: Status
  - iamErrorCode :: Text
  - iamErrorMessage :: Text
  }
- parseDateTime :: MonadThrow m => String -> m UTCTime
- data AccessKeyStatus
  - = AccessKeyActive
  - | AccessKeyInactive
- data User = User {
  - userArn :: Text
  - userCreateDate :: UTCTime
  - userPath :: Text
  - userUserId :: Text
  - userUserName :: Text
  }
- parseUser :: MonadThrow m => Cursor -> m User
- data Group = Group {
  - groupArn :: Text
  - groupCreateDate :: UTCTime
  - groupPath :: Text
  - groupGroupId :: Text
  - groupGroupName :: Text
  }
- parseGroup :: MonadThrow m => Cursor -> m Group
- data MfaDevice = MfaDevice {
  - mfaEnableDate :: UTCTime
  - mfaSerialNumber :: Text
  - mfaUserName :: Text
  }
- parseMfaDevice :: MonadThrow m => Cursor -> m MfaDevice

# Documentation

iamSignQuery Source #

Arguments

:: [(ByteString, ByteString)] | Pairs of parameter names and values that will be passed as part of the request data.
-> IamConfiguration qt |
-> SignatureData |
-> SignedQuery |

Constructs a `SignedQuery` with the specified request parameters.

iamResponseConsumer :: (Cursor -> Response IamMetadata a) -> IORef IamMetadata -> HTTPResponseConsumer a Source #

Reads the metadata from an IAM response and delegates parsing the rest of the data from the response to the given function.

data IamMetadata Source #

Constructors

IamMetadata |

Fields

- requestId :: Maybe Text

#### Instances

Instances details

Loggable IamMetadata Source # |
Instance details Defined in Aws.Iam.Core Methods toLogText :: IamMetadata -> Text Source #
Monoid IamMetadata Source # |
Instance details Defined in Aws.Iam.Core Methods mempty :: IamMetadata Source # mappend :: IamMetadata -> IamMetadata -> IamMetadata Source # mconcat :: [IamMetadata] -> IamMetadata Source #
Semigroup IamMetadata Source # |
Instance details Defined in Aws.Iam.Core Methods (<>) :: IamMetadata -> IamMetadata -> IamMetadata Source # sconcat :: NonEmpty IamMetadata -> IamMetadata Source # stimes :: Integral b => b -> IamMetadata -> IamMetadata Source #
Show IamMetadata Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> IamMetadata -> ShowS Source # show :: IamMetadata -> String Source # showList :: [IamMetadata] -> ShowS Source #

data IamConfiguration qt Source #

Constructors

IamConfiguration |

Fields

- iamEndpoint :: ByteString
- iamPort :: Int
- iamProtocol :: Protocol
- iamHttpMethod :: Method

#### Instances

Instances details

DefaultServiceConfiguration (IamConfiguration NormalQuery) Source # |
Instance details Defined in Aws.Iam.Core Methods defServiceConfig :: IamConfiguration NormalQuery Source # debugServiceConfig :: IamConfiguration NormalQuery Source #
DefaultServiceConfiguration (IamConfiguration UriOnlyQuery) Source # |
Instance details Defined in Aws.Iam.Core Methods defServiceConfig :: IamConfiguration UriOnlyQuery Source # debugServiceConfig :: IamConfiguration UriOnlyQuery Source #
Show (IamConfiguration qt) Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> IamConfiguration qt -> ShowS Source # show :: IamConfiguration qt -> String Source # showList :: [IamConfiguration qt] -> ShowS Source #

data IamError Source #

Constructors

IamError |

Fields

- iamStatusCode :: Status
- iamErrorCode :: Text
- iamErrorMessage :: Text

#### Instances

Instances details

Exception IamError Source # |
Instance details Defined in Aws.Iam.Core Methods toException :: IamError -> SomeException Source # fromException :: SomeException -> Maybe IamError Source # displayException :: IamError -> String Source # backtraceDesired :: IamError -> Bool Source #
Show IamError Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> IamError -> ShowS Source # show :: IamError -> String Source # showList :: [IamError] -> ShowS Source #

parseDateTime :: MonadThrow m => String -> m UTCTime Source #

Parses IAM `DateTime` data type.

data AccessKeyStatus Source #

Constructors

AccessKeyActive |
AccessKeyInactive |

#### Instances

Instances details

Show AccessKeyStatus Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> AccessKeyStatus -> ShowS Source # show :: AccessKeyStatus -> String Source # showList :: [AccessKeyStatus] -> ShowS Source #
Eq AccessKeyStatus Source # |
Instance details Defined in Aws.Iam.Core Methods (==) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source # (/=) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source #
Ord AccessKeyStatus Source # |

Instance details

Defined in Aws.Iam.Core

Methods

compare :: AccessKeyStatus -> AccessKeyStatus -> Ordering Source #

(<) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source #

(<=) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source #

(>) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source #

(>=) :: AccessKeyStatus -> AccessKeyStatus -> Bool Source #

max :: AccessKeyStatus -> AccessKeyStatus -> AccessKeyStatus Source #

min :: AccessKeyStatus -> AccessKeyStatus -> AccessKeyStatus Source #

data User Source #

The IAM `User` data type.

http://docs.aws.amazon.com/IAM/latest/APIReference/API_User.html

Constructors

User |

Fields

- userArn :: Text

  ARN used to refer to this user.

- userCreateDate :: UTCTime

  Date and time at which the user was created.

- userPath :: Text

  Path under which the user was created.

- userUserId :: Text

  Unique identifier used to refer to this user.

- userUserName :: Text

  Name of the user.

#### Instances

Instances details

Show User Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> User -> ShowS Source # show :: User -> String Source # showList :: [User] -> ShowS Source #
Eq User Source # |
Instance details Defined in Aws.Iam.Core Methods (==) :: User -> User -> Bool Source # (/=) :: User -> User -> Bool Source #
Ord User Source # |
Instance details Defined in Aws.Iam.Core Methods compare :: User -> User -> Ordering Source # (<) :: User -> User -> Bool Source # (<=) :: User -> User -> Bool Source # (>) :: User -> User -> Bool Source # (>=) :: User -> User -> Bool Source # max :: User -> User -> User Source # min :: User -> User -> User Source #

parseUser :: MonadThrow m => Cursor -> m User Source #

Parses the IAM `User` data type.

data Group Source #

The IAM `Group` data type.

http://docs.aws.amazon.com/IAM/latest/APIReference/API_Group.html

Constructors

Group |

Fields

- groupArn :: Text

  ARN used to refer to this group.

- groupCreateDate :: UTCTime

  Date and time at which the group was created.

- groupPath :: Text

  Path under which the group was created.

- groupGroupId :: Text

  Unique identifier used to refer to this group.

- groupGroupName :: Text

  Name of the group.

#### Instances

Instances details

Show Group Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> Group -> ShowS Source # show :: Group -> String Source # showList :: [Group] -> ShowS Source #
Eq Group Source # |
Instance details Defined in Aws.Iam.Core Methods (==) :: Group -> Group -> Bool Source # (/=) :: Group -> Group -> Bool Source #
Ord Group Source # |
Instance details Defined in Aws.Iam.Core Methods compare :: Group -> Group -> Ordering Source # (<) :: Group -> Group -> Bool Source # (<=) :: Group -> Group -> Bool Source # (>) :: Group -> Group -> Bool Source # (>=) :: Group -> Group -> Bool Source # max :: Group -> Group -> Group Source # min :: Group -> Group -> Group Source #

parseGroup :: MonadThrow m => Cursor -> m Group Source #

Parses the IAM `Group` data type.

data MfaDevice Source #

The IAM `MFADevice` data type.

https://docs.aws.amazon.com/IAM/latest/APIReference/API_MFADevice.html

Constructors

MfaDevice |

Fields

- mfaEnableDate :: UTCTime

  The date when the MFA device was enabled for the user.

- mfaSerialNumber :: Text

  The serial number that uniquely identifies the MFA device. For virtual MFA devices, the serial number is the device ARN.

- mfaUserName :: Text

  The user with whom the MFA device is associated. Minimum length of 1. Maximum length of 64.

#### Instances

Instances details

Show MfaDevice Source # |
Instance details Defined in Aws.Iam.Core Methods showsPrec :: Int -> MfaDevice -> ShowS Source # show :: MfaDevice -> String Source # showList :: [MfaDevice] -> ShowS Source #
Eq MfaDevice Source # |
Instance details Defined in Aws.Iam.Core Methods (==) :: MfaDevice -> MfaDevice -> Bool Source # (/=) :: MfaDevice -> MfaDevice -> Bool Source #
Ord MfaDevice Source # |
Instance details Defined in Aws.Iam.Core Methods compare :: MfaDevice -> MfaDevice -> Ordering Source # (<) :: MfaDevice -> MfaDevice -> Bool Source # (<=) :: MfaDevice -> MfaDevice -> Bool Source # (>) :: MfaDevice -> MfaDevice -> Bool Source # (>=) :: MfaDevice -> MfaDevice -> Bool Source # max :: MfaDevice -> MfaDevice -> MfaDevice Source # min :: MfaDevice -> MfaDevice -> MfaDevice Source #

parseMfaDevice :: MonadThrow m => Cursor -> m MfaDevice Source #

Parses the IAM `MFADevice` data type.